// ht9̂̂QlɁB

#ifndef _SOUND_H_
#define _SOUND_H_


// TEh̐ݒ

// REG_SGCNT0_L

#define DMG_LEFT_VOLUME(x)	((x))
#define DMG_RIGHT_VOLUME(x)	((x)<<4)

#define SOUND1_LEFT_OUTPUT	(1<<8)
#define SOUND2_LEFT_OUTPUT	(1<<9)
#define SOUND3_LEFT_OUTPUT	(1<<10)
#define SOUND4_LEFT_OUTPUT	(1<<11)
#define SOUND1_RIGHT_OUTPUT	(1<<12)
#define SOUND2_RIGHT_OUTPUT	(1<<13)
#define SOUND3_RIGHT_OUTPUT	(1<<14)
#define SOUND4_RIGHT_OUTPUT	(1<<15)


// REG_SGCNT0_H

#define SOUND_OUTPUT_RATIO(x)	((x)) // TEho̓VI 0-2


// REG_SGCNT1

#define ALL_SOUND_ENABLE		(1<<7) // STEhgp



//----------------------------------------------
// TEh1
// XB[v̂Gx[v

// REG_SG10_L
#define SOUND1_SWEEP_SHIFT(x)	((x)<<0)	// XB[vVtg 0-7
#define SOUND1_SWEEP_INC		(0<<3)		// XB[v
#define SOUND1_SWEEP_DEC		(1<<3)		// XB[v
#define SOUND1_SWEEP_TIME(x)	((x)<<4)	// XB[v 0-7

// REG_SG10_H
#define SOUND1_LENGTH(x)		((x)<<0)	// TEh̒ 0-63
#define SOUND1_DUTY_CYCLE(x)	((x)<<6)	// f[eBTCN 0-3
#define SOUND1_ENVELOP_STEP(x)	((x)<<8)	// Gx[vXebv 0-7
#define SOUND1_ENVELOP_DEC		((0)<<11)	// Gx[v
#define SOUND1_ENVELOP_INC		((1)<<11)	// Gx[v
#define SOUND1_ENVELOP_VALUE(x)	((x)<<12)	// Gx[vl 0-15

// REG_SG11
#define SOUND1_FREQ(x)			((x)<<0)	//  0-2048
#define SOUND1_CONTINUE			(0<<14)		// p
#define SOUND1_TIMED			(1<<14)		// Ԑ
#define SOUND1_RESET			(1<<15)		// TEh1Zbg


//----------------------------------------------
// TEhQ@XB[v̂ȂGx[v
// TEh1REG_SG10_H,REG_SG11Ɠ

// REG_SG20
#define SOUND2_LENGTH(x)		((x)<<0)	// TEh̒ 0-63
#define SOUND2_DUTY_CYCLE(x)	((x)<<6)	// f[eBTCN 0-3
#define SOUND2_ENVELOP_STEP(x)	((x)<<8)	// Gx[vXebv 0-7
#define SOUND2_ENVELOP_DEC		((0)<<11)	// Gx[v
#define SOUND2_ENVELOP_INC		((1)<<11)	// Gx[v
#define SOUND2_ENVELOP_VALUE(x)	((x)<<12)	// Gx[vl 0-15

// REG_SG21
#define SOUND2_FREQ(x)			((x)<<0)	//  0-2048
#define SOUND2_CONTINUE			(0<<14)		// p
#define SOUND2_TIMED			(1<<14)		// Ԑ
#define SOUND2_RESET			(1<<15)		// TEh2Zbg


//----------------------------------------------
// TEhR
// 

// REG_SG30_L
#define SOUND3_BANK_2x32		(0<<5)		// 32bit̃oN
#define SOUND3_BANK_1x64		(1<<5)		// 64bit̃oN

// oNI IĂȂق߂
#define SOUND3_BANK_SELECT(x)	((x)<<6)	// 0-1

#define SOUND3_OUTPUT_ENABLE	(1<<7)		// TEh3o
#define SOUND3_OUTPUT_DISABLE	(0<<7)		// TEh3o͂Ȃ


// REG_SG30_H
#define SOUND3_LENGTH(x)		((x)<<0)	// TEh̒ 0-255
#define SOUND3_VOLUME_RATIO(x)	((x)<<13)	// {[o̓VI 0-4 1100%


// REG_SG31
#define SOUND3_FREQ(x)	((x)<<0)			//  0-2048
#define SOUND3_CONTINUE	(0<<14)				// p
#define SOUND3_TIMED	(1<<14)				// Ԑ
#define SOUND3_RESET	(1<<15)				// TEh1Zbg


// REG_SGWR0
// REG_SGWR0_L
// REG_SGWR0_H
// cREG_SGWR3


//----------------------------------------------
// TEh4

// REG_SG40
#define SOUND4_LENGTH(x)		((x)<<0)	// TEh̒ 0-63
#define SOUND4_ENVELOP_STEP(x)	((x)<<8)	// Gx[vXebv 0-7
#define SOUND4_ENVELOP_DEC		((0)<<11)	// Gx[v
#define SOUND4_ENVELOP_INC		((1)<<11)	// Gx[v
#define SOUND4_ENVELOP_VALUE(x)	((x)<<12)	// Gx[vl 0-15


// REG_SG41
#define SOUND4_DIVIDE_FREQ(x)	((x)<<0)	//  0-7
#define SOUND4_STAGE_15			(0<<3)		// JE^Xe[W
#define SOUND4_STAGE_7			(1<<3)		// 

#define SOUND4_STAGE_FREQ(x)	((x)<<4)	// XebvƂ̎ 0-13
#define SOUND4_CONTINUE			(0<<14)		// p
#define SOUND4_TIMED			(1<<14)		// Ԑ
#define SOUND4_RESET			(1<<15)		// TEh1Zbg
#define SOUND4_SHIFT(x)			((x)<<8)	// TEh SHIFT



// REG_SGCNT_H

// GB4`l̏o̓VI@QTATOAPOO
#define SOUND_GB_RATIO_25	0
#define SOUND_GB_RATIO_50	1
#define SOUND_GB_RATIO_100	2

// DirectSound AEB o̓VI@TOAPOO
#define SOUND_DSOUNDA_RATIO_50	0
#define SOUND_DSOUNDA_RATIO_100	(1<<2)
#define SOUND_DSOUNDB_RATIO_50	0
#define SOUND_DSOUNDB_RATIO_100	(1<<3)

// DirectSoundAẼXs[J[ɏo͂邩
#define SOUND_DSOUNDA_OUTPUT_RIGHT	(1<<8)
#define SOUND_DSOUNDA_OUTPUT_LEFT	(1<<9)

// DirectSoundAŃ^C}[0^C}[P̂ǂgp邩
#define SOUND_DSOUNDA_SAMP_TIMER0	0
#define SOUND_DSOUNDA_SAMP_TIMER1	(1<<10)

// DirectSoundAFIFOZbg
#define SOUND_DSOUNDA_FIFO_RESET	(1<<11)


// DirectSoundBẼXs[J[ɏo͂邩
#define SOUND_DSOUNDB_OUTPUT_RIGHT	(1<<12)
#define SOUND_DSOUNDB_OUTPUT_LEFT	(1<<13)

// DirectSoundBŃ^C}[0^C}[P̂ǂgp邩
#define SOUND_DSOUNDB_SAMP_TIMER0	0
#define SOUND_DSOUNDB_SAMP_TIMER1	(1<<14)

// DirectSoundBFIFOZbg
#define SOUND_DSOUNDB_FIFO_RESET	(1<<15)



#endif

